
#include "User.h"




/************************************************
;  * DemoԷ:
;  *     1ʹ̨ԲDemo  
;  *     2һDemoʱΪ4ms500ms  
;  *     3һDemoʱΪ8ms1000ms 
;  * 
;  * ע⣺demoΪʾʹãʹý϶࣬
;  *       ʵʹõʱ
;  * 
;  * 飺ܸӵĽʹû
;  ***********************************************/



// #define TNms_Value      	131    //(256-131)*32us = 4ms500ms 
#define TNms_Value      6      //(256-6)*32us = 8ms1000ms
#define	TX_LED_P10     	P10D
#define	RX_LED_P11     	P11D


uchar ABuf,StatusBuf;
uchar T1S_Num;
uchar TX_RX_DataLength[5];

volatile flag Flag1;

/************************************************
; Ҫ빦ʱʹã¼ʱӦַչΪID
; ***********************************************/
const uchar __at 0x3f0 ID_Tab[3] = {0xFF,0xFF,0xFF};

/************************************************
;  *    @Function Name       : C_RAM
;  *    @Description         : ʼRAM
;  ***********************************************/
void C_RAM(void)
{
  __asm
   	movai  	0x40
   	movra  	FSR
   	movai  	48
   	movra  	0x07
   	decr   	FSR
   	clrr   	INDF
   	djzr   	0x07
   	goto   	$-3
   	clrr   	INDF
   	clrr   	0x07
  __endasm;
}
/************************************************
;  *    @Function Name       : ConfigSet
;  *    @Description         : IOPWMʱ
;  ***********************************************/
void ConfigSet(void)
{
   	/******************* P0 ********************/
   	P0 = 0x01;   //RF_CSn = 1RF_CE = 1;
   	DDR0 = 0x00; //1:input 0:output
   	P0 = 0x01;   //RF_CSn = 1RF_CE = 1;

   	/******************* P1 ********************/
   	P1 = 0x80; 
   	DDR1 = 0x00; //1:input 0:output
   	P1 = 0x80;

   	/**************** RFʼ *****************/
   	while(0 == RF_Init_Deal());

   	/**************** ʱ0 ******************/
   	T0CR = 0x05;
   	T0CNT = TNms_Value;    	
   	T0IF = 0;
   	T0IE = 1;  	
}

/************************************************
;  *    @Function Name       : InitSys
;  *    @Description         : ϵͳʼ
;  ***********************************************/
void InitSys(void)
{
   	GIE  =  0;
   	C_RAM();
   	ConfigSet();
   	GIE   =  1;
}
//==========================================Main=======================================
void main(void)
{
   	InitSys();
   	while(1)
   	{
   	   	if(0 == TX_RX_Change_Flag)
   	   	{
   	   	   	TX_RX_DataLength[0] = 4;
   	   	   	TX_RX_DataLength[1] = ID_Tab[0];
   	   	   	TX_RX_DataLength[2] = ID_Tab[1];
   	   	   	TX_RX_DataLength[3] = ID_Tab[2];
   	   	   	TX_RX_DataLength[4] = 0x44;
   	   	   	
   	   	   	RF_ResetWriteFIFO_Deal();
   	   	   	RF_WriteFIFO_Deal();
   	   	   	
   	   	   	do
   	   	   	{
   	   	   	   	RF_TX_Deal();
   	   	   	   	RF_TX_PKT_Deal();      	
   	   	   	   	TX_LED_P10 = 1;
   	   	   	}
   	   	   	while(0 == TNms_Flag);
   	   	   	TNms_Flag = 0;
   	   	}
   	   	else 
   	   	{
   	   	   	do
   	   	   	{
   	   	   	   	SPI_ReadReg_Deal(97);
   	   	   	   	if(0x40 == (RF_RegData&0x40))
   	   	   	   	{
   	       	   	   	RF_ReadFIFO_Deal();
   	       	   	   	RF_ResetReadFIFO_Deal();
   	       	   	   	RF_RX_Deal();
   	   	   	   	   	if((0 == RF_ReadFIFOError_Flag)
   	   	   	   	   	&&(4 == TX_RX_DataLength[0])
   	   	   	   	   	&&(ID_Tab[0] == TX_RX_DataLength[1])
   	   	   	   	   	&&(ID_Tab[1] == TX_RX_DataLength[2])
   	   	   	   	   	&&(ID_Tab[2] == TX_RX_DataLength[3])
   	   	   	   	   	&&(0x44 == TX_RX_DataLength[4]))
   	   	   	   	   	{
   	   	   	   	   	   	RX_LED_P11 = 1;        	       	       	       	
   	   	   	   	   	}
   	   	   	   	}
   	   	   	}
   	   	   	while(0 == TNms_Flag);
   	   	   	TNms_Flag = 0;
   	   	}
   	   	T1S_Num++;
   	   	if(T1S_Num>124)
   	   	{
   	   	   	T1S_Num = 0;
   	   	   	if(0 == TX_RX_Change_Flag)
   	   	   	{
   	   	   	   	TX_RX_Change_Flag = 1;
   	   	   	   	TX_LED_P10 = 0;
   	   	   	   	RF_ResetReadFIFO_Deal();
   	   	   	   	RF_RX_Deal();  	       	       	       	
   	   	   	}
   	   	   	else 
   	   	   	{
   	   	   	   	TX_RX_Change_Flag = 0;
   	   	   	   	RX_LED_P11 = 0;
   	   	   	   	RF_Idle_Deal();
   	   	   	}
   	   	}
   	}
}
//=========================================Main End======================================


//========================================== ж =======================================
void int_isr(void) __interrupt
{
   	__asm
   	movra   _ABuf 
   	swapar  _STATUS
   	movra   _StatusBuf
   	__endasm;
   	
   	if((T0IF)&&(T0IE))
   	{
   	   	T0IF = 0;
   	   	T0CNT = TNms_Value;
   	   	TNms_Flag = 1;     	       	
   	}

   	__asm
   	swapar  _StatusBuf
   	movra   _STATUS
   	swapr   _ABuf
   	swapar  _ABuf
   	__endasm;
}