
#include "User.h"




/************************************************
;  * DemoԷ: 
;  * س󣬽ϱ״ߣƵǲԷ书ʡ
;  ***********************************************/



// #define TNms_Value      	131    //(256-131)*32us = 4ms500ms 
#define TNms_Value      6      //(256-6)*32us = 8ms1000ms
#define	TX_LED_P10     	P10D
#define	RX_LED_P11     	P11D


uchar ABuf,StatusBuf;
uchar T1S_Num;
uchar TX_RX_DataLength[5];

volatile flag Flag1;

/************************************************
; Ҫ빦ʱʹã¼ʱӦַչΪID
; ***********************************************/
const uchar __at 0x3f0 ID_Tab[3] = {0xFF,0xFF,0xFF};

/************************************************
;  *    @Function Name       : C_RAM
;  *    @Description         : ʼRAM
;  ***********************************************/
void C_RAM(void)
{
  __asm
   	movai  	0x40
   	movra  	FSR
   	movai  	48
   	movra  	0x07
   	decr   	FSR
   	clrr   	INDF
   	djzr   	0x07
   	goto   	$-3
   	clrr   	INDF
   	clrr   	0x07
  __endasm;
}
/************************************************
;  *    @Function Name       : ConfigSet
;  *    @Description         : IOPWMʱ
;  ***********************************************/
void ConfigSet(void)
{
   	/******************* P0 ********************/
   	P0 = 0x01;   //RF_CSn = 1RF_CE = 1;
   	DDR0 = 0x00; //1:input 0:output
   	P0 = 0x01;   //RF_CSn = 1RF_CE = 1;

   	/******************* P1 ********************/
   	P1 = 0x80; 
   	DDR1 = 0x00; //1:input 0:output
   	P1 = 0x80;

   	/**************** RFʼ *****************/
   	while(0 == RF_Init_Deal());

   	/**************** ʱ0 ******************/
   	T0CR = 0x05;
   	T0CNT = TNms_Value;    	
   	T0IF = 0;
   	T0IE = 1;  	
}

/************************************************
;  *    @Function Name       : InitSys
;  *    @Description         : ϵͳʼ
;  ***********************************************/
void InitSys(void)
{
   	GIE  =  0;
   	C_RAM();
   	ConfigSet();
   	GIE   =  1;
}
/************************************************
;  *    @Function Name       : Direct_Mode
;  *    @Description         : زģʽ
;  ***********************************************/
void Direct_Mode(void)
{
   	SPI_WriteReg_Deal(1,0xF9);
   	
   	SPI_WriteReg_Deal(65,0x01);

   	SPI_WriteReg_Deal(68,0xB0);
   	
   	SPI_WriteReg_Deal(22,0x83);

   	SPI_WriteReg_Deal(14,0x05);
   	
   	SPI_WriteReg_Deal(15,0x4B);
}
//==========================================Main=======================================
void main(void)
{
   	InitSys();
   	Direct_Mode(); 	
   	while(1);
   	   
}
//=========================================Main End======================================


//========================================== ж =======================================
void int_isr(void) __interrupt
{
   	__asm
   	movra   _ABuf 
   	swapar  _STATUS
   	movra   _StatusBuf
   	__endasm;
   	
   	if((T0IF)&&(T0IE))
   	{
   	   	T0IF = 0;
   	   	T0CNT = TNms_Value;
   	   	TNms_Flag = 1;     	       	
   	}

   	__asm
   	swapar  _StatusBuf
   	movra   _STATUS
   	swapr   _ABuf
   	swapar  _ABuf
   	__endasm;
}