#include "MC8020_CDEMO_7343.h"

#define	TX_LED_P10     	P10D
#define	RX_LED_P11     	P11D

//------------------------------------------
//ʱ˺ͽնӦĶֿ
//һʱΪ4msΪ500ms;һʱΪ8msΪ1000ms
#define	TNms_Value     	125//125*32us=4ms

//#define      	TNms_Value     	250;250*32us=8ms

u8 ABuf,StatusBuf;
u8 T1S_Num;
u8 RF_ChannelValue;
u8 TX_RX_DataLength[5];

extern 	uchar RF_RegData;
volatile Flag Flag1;

void Init_IO(void);
void Init_RAM(void);
void Init_Timer(void);


const uchar __at 0x01 ID_Tab[3]={0xFF,0xFF,0xFF};
//------------------------------
//SPI_CSn=1
void Init_IO(void)
{
   	IOP0=0x00;
   	OEP0=0xFE;
   	IOP0=0x00;
   	
   	IOP1=0x20;
   	OEP1=0xFF;
   	IOP1=0x20;

   	IOP2=0x00;
   	OEP2=0xFF;
   	IOP2=0x00;
}
//------------------------------
void Init_RAM(void)
{
   	for(FSR0=0;FSR0<0xff;FSR0++) 
   	{
   	   	INDF0=0;
   	}
   	FSR0=0xFF;
   	INDF0=0;
   	for(FSR1=0;FSR1<0x80;FSR1++)
   	{
   	   	INDF1=0;
   	}
}
//------------------------------
void Init_Timer(void)
{
   	T0CR=0x86;
   	T0CNT=TNms_Value;
   	T0LOAD=TNms_Value;
   	
   	T0IF=0;
   	T0IE=1;	
}
//------------------------------
void main(void)
{
   	Init_IO();
   	Init_RAM();
   	while(0==RF_Init_Deal());
   	Init_Timer();
   	GIE=1;
   	
   	RF_ChannelValue=0;
   	
   	while(1)
   	{
   	   	if(0==TX_RX_Change_Flag)
   	   	{
   	   	   	TX_RX_DataLength[0]=4;
   	   	   	TX_RX_DataLength[1]=ID_Tab[0];
       	   	   	TX_RX_DataLength[2]=ID_Tab[1];
       	   	   	TX_RX_DataLength[3]=ID_Tab[2];
   	   	   	TX_RX_DataLength[4]=0x44;
   	   	   	
   	   	   	RF_ResetWriteFIFO_Deal();
   	   	   	RF_WriteFIFO_Deal();
   	   	   	
   	   	   	do
   	   	   	{
   	   	   	   	RF_TX_Deal();
   	   	   	   	RF_TX_PKT_Deal();      	
   	   	   	   	TX_LED_P10=1;
   	   	   	}
   	   	   	while(0==TNms_Flag);
   	   	   	TNms_Flag=0;
   	   	}
   	   	else 
   	   	{
   	   	   	do
   	   	   	{
   	   	   	   	SPI_ReadReg_Deal(97);
   	   	   	   	if(0x40==(RF_RegData&0x40))
   	   	   	   	{
   	       	RF_ReadFIFO_Deal();
   	       	RF_ResetReadFIFO_Deal();
   	       	RF_RX_Deal();
   	       	if((0==RF_ReadFIFOError_Flag)&&
   	       	(4==TX_RX_DataLength[0])&&
   	       	(ID_Tab[0]==TX_RX_DataLength[1])&&
       	       	(ID_Tab[1]==TX_RX_DataLength[2])&&
       	       	(ID_Tab[2]==TX_RX_DataLength[3])&&
   	       	(0x44==TX_RX_DataLength[4]))
   	       	{
   	       	   	RX_LED_P11=1;  	       	       	       	       	       	
   	       	}
   	   	   	   	}      	       	       	       	
   	   	   	}
   	   	   	while(0==TNms_Flag);
   	   	   	TNms_Flag=0;
   	   	}
   	   	T1S_Num++;
   	   	if(T1S_Num>124)
   	   	{
   	   	   	T1S_Num=0;
   	   	   	if(0==TX_RX_Change_Flag)
   	   	   	{
   	   	   	   	TX_RX_Change_Flag=1;
   	   	   	   	TX_LED_P10=0;
   	   	   	   	RF_ResetReadFIFO_Deal();
   	   	   	   	RF_RX_Deal();  	       	       	       	
   	   	   	}
   	   	   	else 
   	   	   	{
   	   	   	   	TX_RX_Change_Flag=0;
   	   	   	   	RX_LED_P11=0;
   	   	   	   	RF_Idle_Deal();
   	   	   	}
   	   	}
   	}
}

//------------------------------
void int_isr(void) __interrupt
{
   	__asm
   	movra   _ABuf
   	swapar  _PFLAG
   	movra   _StatusBuf
   	__endasm;
   	
   	if(1==T0IF)
   	{
   	   	T0IF=0;
   	
   	   	TNms_Flag=1;   	       	
   	}

   	__asm
   	swapar  _StatusBuf
   	movra   _PFLAG
   	swapr   _ABuf
   	swapar  _ABuf
   	__endasm;
}