
#include "User.h"





/************************************************
;  * DemoԷ:
;  *     1ʹ̨ԲDemo  
;  *     2һDemoʱΪ4ms500ms  
;  *     3һDemoʱΪ8ms1000ms 
;  * 
;  * ע⣺demoΪʾʹãʹý϶࣬
;  *       ʵʹõʱ
;  * 
;  * 飺ܸӵĽʹû
;  ***********************************************/

//===============Define===============
// #define TNms_Value      	131    //(256-131)*32us  =  4ms500ms 
#define TNms_Value      6      //(256-6)*32us  =  8ms1000ms
#define	TX_LED_P12     	P12D
#define	RX_LED_P11     	P11D

//===============Variables===============
u8 abuf,statusbuf;
u8 T1S_Num;
u8 TX_RX_DataLength[5];

volatile bit_flag Flag1;

/************************************************
; Ҫ빦ʱʹã¼ʱӦַչΪID
; ***********************************************/
const uchar __at 0x3f0 ID_Tab[3]  =  {0xFF,0xFF,0xFF};

/************************************************
;  *    @Function Name       : C_RAMP
;  *    @Description         : RAM
;  ***********************************************/
void C_RAM(void)
{
    for (FSR0 = 0; FSR0 < 0xff; FSR0++)
    {
        INDF0 = 0;
    }
    FSR0 = 0xFF;
    INDF0 = 0;
}
/************************************************
;  *    @Function Name       : ConfigSet
;  *    @Description         : ͨIO
;  ***********************************************/
void ConfigSet(void)
{
   /******************* I/O ********************/
    IOP0 = 0x80;  //RF_CE  = 1;
    IOP1 = 0x08;  //RF_CSn = 1;
    IOP2 = 0x00;

    OEP0 = 0xf7;  //P0  out   PKT  P03 Input
    OEP1 = 0xff;  //P1  out
    OEP2 = 0xff;  //P2  out

    PUP0 = 0x00;
    PUP1 = 0x00;
    PUP2 = 0x00;

    PDP0 = 0x00;
    PDP1 = 0x00;
    PDP2 = 0x00;
   /**************** RFʼ *****************/
    while(0  ==  RF_Init_Deal());
   /**************** ʱ0 *****************/
    T0CR = DEF_SET_BIT1 | DEF_SET_BIT2;//CPU,64Ƶ
    T0CNT = TNms_Value;
    T0LOAD = TNms_Value; 
    T0EN = 1;
    T0IE = 1;
}
/************************************************
;  *    @Function Name       : InitSys
;  *    @Description         : ϵͳʼ
;  ***********************************************/
void InitSys(void)
{
   	GIE = 0;
   	C_RAM();
   	ConfigSet();
   	GIE = 1;
}


void main(void)
{
    InitSys();
    while (1)
    {
        if(0 == TX_RX_Change_Flag)
   	   	{
   	   	   	TX_RX_DataLength[0] = 4;
   	   	   	TX_RX_DataLength[1] = ID_Tab[0];
   	   	   	TX_RX_DataLength[2] = ID_Tab[1];
   	   	   	TX_RX_DataLength[3] = ID_Tab[2];
   	   	   	TX_RX_DataLength[4] = 0x44;
   	   	   	
   	   	   	RF_ResetWriteFIFO_Deal();
   	   	   	RF_WriteFIFO_Deal();
   	   	   	
   	   	   	do
   	   	   	{
   	   	   	   	RF_TX_Deal();
   	   	   	   	RF_TX_PKT_Deal();      	
   	   	   	   	TX_LED_P12 = 1;
   	   	   	}
   	   	   	while(0 == TNms_Flag);
   	   	   	TNms_Flag = 0;
   	   	}
   	   	else 
   	   	{
   	   	   	do
   	   	   	{
   	   	   	   	SPI_ReadReg_Deal(97);
   	   	   	   	if(0x40 == (RF_RegData&0x40))
   	   	   	   	{
   	       	   	   	RF_ReadFIFO_Deal();
   	       	   	   	RF_ResetReadFIFO_Deal();
   	       	   	   	RF_RX_Deal();
   	   	   	   	   	if((0 == RF_ReadFIFOError_Flag)
   	   	   	   	   	&&(4 == TX_RX_DataLength[0])   	   	   	   	   	
   	   	   	   	   	&&(ID_Tab[0] == TX_RX_DataLength[1])   	   	   	   	   	
   	   	   	   	   	&&(ID_Tab[1] == TX_RX_DataLength[2])   	   	   	   	   	
   	   	   	   	   	&&(ID_Tab[2] == TX_RX_DataLength[3])   	   	   	   	   	
   	   	   	   	   	&&(0x44 == TX_RX_DataLength[4]))   	   	   	   	
   	   	   	   	   	{
   	   	   	   	   	   	RX_LED_P11 = 1;    	       	       	       	       	       	
   	   	   	   	   	}
   	   	   	   	}      	       	       	       	
   	   	   	}
   	   	   	while(0 == TNms_Flag);
   	   	   	TNms_Flag = 0;
   	   	}
   	   	T1S_Num++;
   	   	if(T1S_Num>124)
   	   	{
   	   	   	T1S_Num = 0;
   	   	   	if(0 == TX_RX_Change_Flag)
   	   	   	{
   	   	   	   	TX_RX_Change_Flag = 1;
   	   	   	   	TX_LED_P12 = 0;
   	   	   	   	RF_ResetReadFIFO_Deal();
   	   	   	   	RF_RX_Deal();  	       	       	       	
   	   	   	}
   	   	   	else 
   	   	   	{
   	   	   	   	TX_RX_Change_Flag = 0;
   	   	   	   	RX_LED_P11 = 0;
   	   	   	   	RF_Idle_Deal();
   	   	   	}
   	   	}
    }
}

void int_isr(void) __interrupt
{
__asm 
    movra _abuf
    swapar _PFLAG
    movra _statusbuf
__endasm;
    if ((T0IF) && (T0IE))
    {
        T0IF = 0;
        TNms_Flag=1;
    }
__asm
    swapar _statusbuf
    movra _PFLAG
    swapr _abuf
    swapar _abuf
__endasm;
}

/**************************** end of file *********************************************/
