;*********************************
RF_InitTab:
       	addra  	       	PCL
;---------------------------------
       	retai  	       	17
       	retai  	       	0x3A
;---------------------------------
       	retai  	       	18     	       	;--书
       	retai  	       	0x0C
;---------------------------------
       	retai  	       	34
       	retai  	       	0x08
;---------------------------------
       	retai  	       	45
       	retai  	       	0x00
;---------------------------------
       	retai  	       	52
       	retai  	       	0x19
;---------------------------------
       	retai  	       	53
       	retai  	       	0x40
;---------------------------------
       	retai  	       	64     	       	;--ݰʽ
       	retai  	       	0x78
;==========  SyncWord  ===========
        retai  	       	72
        retai  	       	0x55
;---------------------------------
       	retai  	       	73
       	retai  	       	0x55
;---------------------------------
       	retai  	       	74
       	retai  	       	0x55
;---------------------------------
       	retai  	       	75
       	retai  	       	0x55
;---------------------------------
       	retai  	       	76
       	retai  	       	0xAA 
;---------------------------------
       	retai  	       	77
       	retai  	       	0x3E
;---------------------------------
       	retai  	       	78
       	retai  	       	0x57
;---------------------------------
       	retai  	       	79
       	retai  	       	0xE4
;=================================
       	retai  	       	80
       	retai  	       	0xF8
;---------------------------------
       	retai  	       	81     	       	
       	retai  	       	0x47
;============  Finish  ===========
       	retai  	       	0xFF
       
;*********************************
RF_Init_Deal:
       	movai  	       	40
       	call   	       	Delay_100us_Deal       	

       	bclr   	       	SPI_CKPHA_Flag

       	movai  	       	30
       	movra  	       	RF_RegAddr

       	movai  	       	0x00
       	movra  	       	RF_RegData             	

       	call   	       	SPI_WriteReg_Deal

       	bset   	       	SPI_CKPHA_Flag

       	movai  	       	94
       	movra  	       	RF_RegAddr

       	movai  	       	0x80
       	movra  	       	RF_RegData
       	
       	call   	       	SPI_WriteReg_Deal
       	;---------------
       	clrr   	       	RF_InitIndex
RF_Init_Loop:
        movar  	       	RF_InitIndex
        call   	       	RF_InitTab
        movra  	       	RF_RegAddr
        xorai  	       	0xFF
        jbclr  	       	Z
        goto   	       	RF_Init_Over
        incr   	       	RF_InitIndex
        movar  	       	RF_InitIndex
        call   	       	RF_InitTab
        movra  	       	RF_RegData
        movra  	       	RF_RegData_Temp
        
        call   	       	SPI_WriteReg_Deal
       	;---------------
       	call   	       	SPI_ReadReg_Deal
       	movar  	       	RF_RegData_Temp
       	rsubar 	       	RF_RegData
        jbset  	       	Z
        goto   	       	RF_Init_Deal
        incr   	       	RF_InitIndex
        goto   	       	RF_Init_Loop
RF_Init_Over:
       	movai  	       	46
       	movra  	       	RF_RegAddr
       	movai  	       	0x09
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal              	
       	return
;*********************************
RF_TX_Deal:
       	movai  	       	15
       	movra  	       	RF_RegAddr
       	movar  	       	RF_ChannelValue
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal
       
       	movai  	       	14
       	movra  	       	RF_RegAddr
       	movai  	       	0x01
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal
       
       	return
;*********************************        
RF_TX_PKT_Deal:
       	movai  	       	97
       	movra  	       	RF_RegAddr
       	call   	       	SPI_ReadReg_Deal
       	
       	movai  	       	0x40
       	andar  	       	RF_RegData
       	jbclr  	       	Z
       	goto   	       	RF_TX_PKT_Deal
       	return
;*********************************
RF_TX_250K_Deal:
       	movai  	       	64
       	movra  	       	RF_RegAddr
       	movai  	       	0x68
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal

       	movai  	       	106
       	movra  	       	RF_RegAddr
       	movai  	       	0x68
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal              	

       	movai  	       	107
       	movra  	       	RF_RegAddr
       	movai  	       	0xC3
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal

       	movai  	       	108
       	movra  	       	RF_RegAddr
       	movai  	       	0x16
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal

       	movai  	       	109
       	movra  	       	RF_RegAddr
       	movai  	       	0x7C
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal              	

       	movai  	       	110
       	movra  	       	RF_RegAddr
       	movai  	       	0x6E
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal

       	movai  	       	111
       	movra  	       	RF_RegAddr
       	movai  	       	0xA1
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal

       	return
;*********************************
RF_RX_Deal:
       	movai  	       	14
       	movra  	       	RF_RegAddr
       	clrr   	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal
       
       	movai  	       	15
       	movra  	       	RF_RegAddr
       	movar  	       	RF_ChannelValue
       	orai   	       	0x80
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal
       
       	return
;*********************************
RF_RX_250K_Deal:
       	movai  	       	64
       	movra  	       	RF_RegAddr
       	movai  	       	0x68
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal

       	movai  	       	106
       	movra  	       	RF_RegAddr
       	movai  	       	0x68
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal              	

       	movai  	       	107
       	movra  	       	RF_RegAddr
       	movai  	       	0xC3
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal

       	movai  	       	108
       	movra  	       	RF_RegAddr
       	movai  	       	0x7A
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal

       	movai  	       	109
       	movra  	       	RF_RegAddr
       	movai  	       	0x89
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal              	

       	movai  	       	110
       	movra  	       	RF_RegAddr
       	movai  	       	0xC1
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal

       	movai  	       	111
       	movra  	       	RF_RegAddr
       	movai  	       	0x97
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal

       	return
;*********************************
RF_Idle_Deal:
       	movai  	       	14
       	movra  	       	RF_RegAddr
       	clrr   	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal
       
       	movai  	       	15
       	movra  	       	RF_RegAddr
       	clrr   	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal
       
       	return 	  
;*********************************
RF_Sleep_Deal:
       	movai  	       	70
       	movra  	       	RF_RegAddr
       	call   	       	SPI_ReadReg_Deal
       	movai  	       	0x40
       	orra   	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal

       	return
;*********************************
RF_Wakeup_Deal:
       	bclr   	       	RF_CSn
       	movai  	       	40
       	call   	       	Delay_100us_Deal
       	bset   	       	RF_CSn

       	return       
;*********************************
RF_WriteFIFO_Deal:
       	bclr   	       	RF_CSn
       	movai  	       	100
       	call   	       	SPI_WriteBit_Deal
       	
       	movar  	       	TX_RX_DataLength
       	addai  	       	1
       	movra  	       	TX_RX_DataLength_Temp
       
       	movai  	       	TX_RX_DataLength
       	movra  	       	FSR
RF_WriteFIFO_Loop:
       	movar  	       	INDF
       	call   	       	SPI_WriteBit_Deal
       	
       	incr   	       	FSR
       	djzr   	       	TX_RX_DataLength_Temp
       	goto   	       	RF_WriteFIFO_Loop
       
       	bset   	       	RF_CSn
       	return
;********************************* 
RF_ResetWriteFIFO_Deal:
       	movai  	       	104
       	movra  	       	RF_RegAddr
       	movai  	       	0x80
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal
       	return
;*********************************
RF_ReadFIFO_Deal:
       	bclr   	       	RF_ReadFIFOError_Flag

       	movai  	       	96
       	movra  	       	RF_RegAddr
       	call   	       	SPI_ReadReg_Deal
       	movar  	       	RF_RegData
       	andai  	       	0x80
       	jbset  	       	Z
       	goto   	       	RF_ReadFIFOError_Deal
       
       	bclr   	       	RF_CSn
       	movai  	       	100
       	orai   	       	0x80
       	call   	       	SPI_WriteBit_Deal
       	nop
       	nop
       	call   	       	SPI_ReadBit_Deal
       	movra  	       	TX_RX_DataLength

       	movar  	       	TX_RX_DataLength
       	isubai 	       	RX_DataLengthMax_Value
       	jbset  	       	C
       	goto   	       	RF_ReadFIFOError_Deal

       	movar  	       	TX_RX_DataLength
       	jbclr  	       	Z
       	goto   	       	RF_ReadFIFOError_Deal
       
       	movai  	       	TX_RX_DataLength+1
       	movra  	       	FSR
       	clrr   	       	TX_RX_DataLength_Temp
RF_ReadFIFO_Loop:
       	call           	SPI_ReadBit_Deal
       	movra  	       	INDF
       	incr   	       	FSR
       	incr   	       	TX_RX_DataLength_Temp
       	movar  	       	TX_RX_DataLength       	
       	rsubar 	       	TX_RX_DataLength_Temp
       	jbset  	       	Z
       	goto   	       	RF_ReadFIFO_Loop
RF_ReadFIFO_Over:
       	bset   	       	RF_CSn
       	return
RF_ReadFIFOError_Deal:
       	bset   	       	RF_ReadFIFOError_Flag       
       	goto   	       	RF_ReadFIFO_Over
;*********************************
RF_ResetReadFIFO_Deal:
       	movai  	       	105
       	movra  	       	RF_RegAddr
       	movai  	       	0x80
       	movra  	       	RF_RegData
       	call   	       	SPI_WriteReg_Deal
       	return       
;*********************************         
SPI_WriteReg_Deal:
       	bclr   	       	RF_CSn
       	movar  	       	RF_RegAddr
       	call   	       	SPI_WriteBit_Deal
       	nop
       	movar  	       	RF_RegData
       	call   	       	SPI_WriteBit_Deal
       	nop
       	bset   	       	RF_CSn
       	return
;*********************************             	
SPI_WriteBit_Deal:
       	movra  	       	SPI_BUF

       	#if    	RF_MOSI_Output
       	bset   	       	RF_MOSI_MISO_DDR
       	#else 
       	bclr   	       	RF_MOSI_MISO_DDR
       	#endif

       	movai  	       	0x08
       	movra  	       	SPI_Cyc_Cnt
SPI_WriteBit_LoopA:
       	jbclr  	       	SPI_CKPHA_Flag
       	goto   	       	$+3
       	bset   	       	RF_CLK
       	goto   	       	$+2
       	bclr   	       	RF_CLK
       	rlr    	       	SPI_BUF
       	jbclr  	       	C
       	goto   	       	SPI_WriteBit_Set
       	bclr   	       	RF_MOSI_MISO
       	goto   	       	SPI_WriteBit_LoopB
SPI_WriteBit_Set:
       	bset   	       	RF_MOSI_MISO
SPI_WriteBit_LoopB:
       	nop
       	nop
       	jbclr  	       	SPI_CKPHA_Flag
       	goto   	       	$+3
       	bclr   	       	RF_CLK
       	goto   	       	$+2
       	bset   	       	RF_CLK
       	nop
       	nop
       	djzr   	       	SPI_Cyc_Cnt
       	goto   	       	SPI_WriteBit_LoopA
       	nop
       	bclr   	       	RF_CLK
       	bclr   	       	RF_MOSI_MISO
       	return
;*********************************
SPI_ReadReg_Deal:
       	bclr   	       	RF_CSn
       	movar  	       	RF_RegAddr
       	orai   	       	0x80
       	call   	       	SPI_WriteBit_Deal
       	nop
       	call   	       	SPI_ReadBit_Deal
       	movra  	       	RF_RegData
       	nop
       	bset   	       	RF_CSn

       	#if    	RF_MOSI_Output
       	bset   	       	RF_MOSI_MISO_DDR
       	#else 
       	bclr   	       	RF_MOSI_MISO_DDR
       	#endif
       
       	return
;*********************************       
SPI_ReadBit_Deal:
       	#if RF_MOSI_Input
       	bset   	       	RF_MOSI_MISO_DDR
       	#else 
       	bclr   	       	RF_MOSI_MISO_DDR
       	#endif

       	clrr   	       	SPI_BUF
       	movai  	       	0x08
       	movra  	       	SPI_Cyc_Cnt
SPI_ReadBit_Loop:
       	jbclr  	       	SPI_CKPHA_Flag
       	goto   	       	$+3
       	bset   	       	RF_CLK
       	goto   	       	$+2
       	bclr   	       	RF_CLK
       	nop
       	nop

       	jbclr  	       	SPI_CKPHA_Flag
       	goto   	       	$+3
       	bclr   	       	RF_CLK
       	goto   	       	$+2
       	bset   	       	RF_CLK

       	nop
       	nop
       	bclr   	       	C
       	jbclr  	       	RF_MOSI_MISO
       	bset   	       	C

       	rlr    	       	SPI_BUF
       	djzr   	       	SPI_Cyc_Cnt
       	goto   	       	SPI_ReadBit_Loop
       	bclr   	       	RF_CLK
       	movar  	       	SPI_BUF
       	return
;********************************* 
Delay_100us_Deal:
       	movra  	       	Delay_100us_Num1
Delay_100us_Loop:
       	movai  	       	Delay_100us_Num_Temp
        movra  	       	Delay_100us_Num2
        djzr   	       	Delay_100us_Num2
        goto   	       	$-1
        djzr   	       	Delay_100us_Num1
        goto   	       	Delay_100us_Loop
        return
;*********************************
RF_SetSyncWord_Deal:
       	movai  	       	SyncWord_Addr1
       	movra  	       	RF_RegAddr
       	movai  	       	SyncWord_Data1
       	movra  	       	RF_RegData
       	call           	SPI_WriteReg_Deal

       	movai  	       	SyncWord_Addr2
       	movra  	       	RF_RegAddr
       	movai  	       	SyncWord_Data2
       	movra  	       	RF_RegData
       	call           	SPI_WriteReg_Deal

       	movai  	       	SyncWord_Addr3
       	movra  	       	RF_RegAddr
       	movai  	       	SyncWord_Data3
       	movra  	       	RF_RegData
       	call           	SPI_WriteReg_Deal

       	movai  	       	SyncWord_Addr4
       	movra  	       	RF_RegAddr  
       	movai  	       	SyncWord_Data4
       	movra  	       	RF_RegData
       	call           	SPI_WriteReg_Deal
       
       	return 